;
(function(undefined) {
  "use strict"
  var _global
  // 工具函数
  // 对象合并
  function extend(o, n, override) {
    for (var key in n) {
      if (n.hasOwnProperty(key) && (!o.hasOwnProperty(key) || override)) {
        o[key] = n[key]
      }
    }
    return o
  }
  //设置style
  function set_style(dom, style) {
    for (var o in style) {
      dom.style[o] = style[o]
    }
  }
  //设置阴影
  const prset = ['1,4,.117647', '3,10,.156863', '10,18,.219608', '15,20,.219608']

  function setShadow(el, str) {
    let arr
    if (typeof(str) == 'number') {
      arr = prset[str].split(',') || '0,0,0'
    } else {
      arr = str.split(',')
    }
    let x = arr[0],
      y = arr[1],
      opacity = arr[2]
    el.style['box-shadow'] = `0 ${x}px ${y}px 0 rgba(0, 0, 0, ${opacity}), 0 ${x}px ${y}px 0 rgba(0, 0, 0, ${opacity})`
  }
  // 插件构造函数 - 返回数组结构

  function toast_class(opt) {
    this._initial(opt)
  }
  toast_class.prototype = {
    constructor: this,
    _initial(opt) {
      // 默认参数
      var def = {
        msg: '提示信息',
        duration: 2500,
        closable: false,
        closableSize: '8px',
        closableWidth: '1px',
        type: 'default',
        translateY: '40px',
        minWidth: '70px',
        maxWidth: '200px',
        backgroundColor: '',
        textColor: '#fff',
        loadingSize: '15px',
        loadingBorderSize: '2px',
        autoClose: true,
        style:{}
      }
      this.def = extend(def, opt, true)
      if (opt) {
        if (opt.msg === undefined) {
          this.def.msg = opt
        }
      }
      this.create()
    },
    create() {
      let g_toast = document.createElement('div')
      let g_style = this.parent_style()
      g_style = extend(g_style, this.def.style, true)
      set_style(g_toast, g_style)
      if (this.def.type === 'loading') {
        let loading = this.create_loading()
        g_toast.appendChild(loading)
        let msg = document.createElement('div')
        msg.innerHTML = this.def.msg
        g_toast.appendChild(msg)
      } else {
        g_toast.innerHTML = this.def.msg
      }
      if (this.def.closable) {
        let closable = this.create_close_icon()
        g_toast.appendChild(closable)
      }
      let animate = g_toast.animate([{
          transform: 'translateY(0)',
          opacity: 0
        },
        {
          transform: `translateY(${this.def.translateY})`,
          opacity: 1
        }
      ], 400)

      animate.onfinish = () => {
        g_toast.style.transform = `translateY(${this.def.translateY})`
        g_toast.style.opacity = 1
      }
      document.documentElement.appendChild(g_toast)
      g_toast.style.left = `calc(50vw - ${g_toast.clientWidth/2}px)`
      this.dom = g_toast
      if (!this.def.closable && this.def.autoClose) {
        setTimeout(() => {
          this.close()
        }, this.def.duration)
      }
    },
    parent_style() {
      let arr = '3,10,.156863'.split(',')
      let x = arr[0],
        y = arr[1],
        opacity = arr[2]
      let bgColor = {
        default: 'rgb(126, 132, 140)',
        info: 'rgb(80, 167, 248)',
        warning: '#fd9827',
        success: '#28bd6e',
        error: 'rgb(255, 82, 82)'
      }
      let style = {
        textAlign: 'center',
        fontSize: '10px',
        padding: '10px',
        minWidth: this.def.minWidth,
        maxWidth: this.def.maxWidth,
        borderRadius: '2px',
        boxShadow: `0 ${x}px ${y}px 0 rgba(0, 0, 0, ${opacity}), 0 ${x}px ${y}px 0 rgba(0, 0, 0, ${opacity})`,
        color: this.def.textColor,
        backgroundColor: this.def.backgroundColor || bgColor[this.def.type] || 'rgb(126, 132, 140)',
        position: 'fixed',
        zIndex: '999',
        top: '0',
        opacity: 0
      }
      return style
    },
    loading_style() {
      let style = {
        width: this.def.loadingSize,
        height: this.def.loadingSize,
        borderRadius: '50%',
        background: 'none',
        border: `${this.def.loadingBorderSize} solid rgba(255,255,255,.5)`,
        borderTop: `${this.def.loadingBorderSize} solid rgba(255,255,255,1)`,
        margin: '0 auto',
        marginBottom: '5px'
      }
      return style
    },
    create_loading() {
      let loading = document.createElement('div')
      let style = this.loading_style()
      set_style(loading, style)
      let animate = loading.animate([{
          transform: 'rotate(0)',
        },
        {
          transform: 'rotate(360deg)',
        }
      ], 1200)
      let timer = setInterval(() => {
        animate.play()
      })
      this.loading_timer = timer
      return loading
    },
    close_icon_style() {
      let style = {
        width: this.def.closableWidth,
        height: this.def.closableSize,
        borderRadius: this.def.closableWidth,
        background: '#fff',
        position: 'absolute',
        top:0,
        right:0
      }
      let width = this.def.closableSize.split('px')[0]
      style.right = Math.sqrt(width*width/2)/2+'px'
      return style
    },
    create_close_icon() {
      let g_close = document.createElement('div')
      g_close.style.position = "absolute"
      g_close.style.right = "5px"
      g_close.style.top = "5px"
      g_close.style.cursor = "pointer"
      g_close.style.width = this.def.closableSize
      g_close.style.height = this.def.closableSize
      let close_item = document.createElement('div')
      let close_item_style = this.close_icon_style()
      set_style(close_item, close_item_style)
      close_item.style.transform = 'rotate(45deg)'
      g_close.appendChild(close_item)
      let close_item1 = document.createElement('div')
      set_style(close_item1, close_item_style)
      close_item1.style.transform = 'rotate(-45deg)'
      g_close.appendChild(close_item1)
      g_close.addEventListener('click', () => {
        this.close()
      })
      return g_close
    },
    close() {
      let promise = new Promise((resolve, reject) => {
        let animate = this.dom.animate([{
            opacity: 1,
            transform: `translateY(${this.def.translateY})`
          },
          {
            opacity: 0,
            transform: 'translateY(0)'
          }
        ], 400)
        animate.onfinish = () => {
          resolve()
        }
      })
      promise.then(() => {
        this.dom.remove()
        clearInterval(this.loading_timer)
      })
    }
  }

  function toast(opt) {
    let toast_item = new toast_class(opt)
    return toast_item
  }
  let toast_types = ['default', 'info', 'warning', 'success', 'error', 'loading']
  toast_types.forEach((item) => {
    toast[item] = (opt) => {
      let resultOpt = {
        type: item
      }
      if (opt) {
        if (opt.msg || opt.type) {
          resultOpt = opt
          resultOpt.type = item
        } else {
          resultOpt.msg = opt
        }
      }
      let toast_item = new toast_class(resultOpt)
      return toast_item
    }
  })
  // 最后将插件对象暴露给全局对象
  _global = (function() {
    return this || (0, eval)('this')
  }())
  if (typeof module !== "undefined" && module.exports) {
    module.exports = toast
  } else if (typeof define === "function" && define.amd) {
    define(function() {
      return toast
    });
  } else {
    !('toast' in _global) && (_global.toast = toast)
  }
}());
